/******************************************************************/
/* Description :  PM Report interface header file.                */
/* Author      :  Tarek Hammoud                                   *
/* Date        :  01/01/93                                        *
/* Last        :  09/23/93                                        *
/* Version     :  1.1                                             *
/******************************************************************/

#ifndef INCLUDED_REPORT
 #define INCLUDED_REPORT

/******************************/
/*         Class Name         */
/******************************/

#define  szReportClass  "Report Class"

/******************************/
/*       Control Styles       */
/******************************/

#define  RS_DRAFTMODE    0x00000001L


/******************************/
/*      Control Messages      */
/******************************/

#define RPM_SETFILE                 (WM_USER + 10)
#define RPM_QUERYFILE               (WM_USER + 11)
#define RPM_SETPRINTER              (WM_USER + 12)
#define RPM_QUERYPRINTER            (WM_USER + 13)
#define RPM_SETVIEWSCALE            (WM_USER + 14)
#define RPM_QUERYVIEWSCALE          (WM_USER + 15)
#define RPM_PRINT                   (WM_USER + 16)
#define RPM_SETMARGINVIEW           (WM_USER + 17)
#define RPM_QUERYMARGINVIEW         (WM_USER + 18)
#define RPM_SETCURRENTPAGE          (WM_USER + 19)
#define RPM_QUERYCURRENTPAGE        (WM_USER + 20)
#define RPM_SETMARGINS              (WM_USER + 21)
#define RPM_QUERYMARGINS            (WM_USER + 22)
#define RPM_PAGINATE                (WM_USER + 23)
#define RPM_STOPPRINT               (WM_USER + 25)
#define RPM_QUERYPAGECOUNT          (WM_USER + 29)
#define RPM_QUERYPAGESIZE           (WM_USER + 30)

#define RF_NORMAL                   0x0000
#define RF_MEMORY                   0x0001

/******************************/
/*Use with RPM_SETCURRENTPAGE */
/******************************/

#define PAGE_TOP        -1
#define PAGE_BOTTOM     -2
#define PAGE_NEXT       -3
#define PAGE_PREVIOUS   -4

/*******************************************/
/* Control Notification codes              */
/*                                         */
/* SHORT1FROMMP(mp1) has Control ID        */
/* SHORT2FROMMP(mp1) has Notify ID         */
/* SHORT1FROMMP(mp2) has error code        */
/* SHORT2FROMMP(mp2) has line number that  */
/* sent the message. Debugging purposes    */
/*******************************************/


#define RN_PAGINATING       1     /* Control is paginating document */
#define RN_PRINTING         2     /* Page was printed               */
#define RN_LOADING          3     /* Control is loading document    */
#define RN_PRINTCOMPLETE    4     /* Printing has completed         */
#define RN_SETCURRENTPAGE   5     /* New page has been set          */
#define RN_ERROR            6     /* Error Occured. See error Codes */

/*********************/
/*  Error Codes      */
/*********************/

#define ERROR_MEMORY          1     /* Memory Error                      */
#define ERROR_SYSTEM          2     /* System Errors. Win/Gpi/Dos errors */
#define ERROR_TABOVERFLOW     3     /* Can not insert more Tabs          */
#define ERROR_POINTSIZE       4     /* Point size is 0                   */
#define ERROR_FONT_DEFAULT    5     /* Using default Font                */
#define ERROR_PRINT           6     /* Print Error                       */
#define ERROR_BITMAP          7     /* Bitmap Error                      */
#define ERROR_DEFAULT_PRINTER 8     /* Could not locate default printer  */

/*************************************************************/
/* Class registration function                               */
/* Manual registration should provide 8 bytes of extra space.*/
/*************************************************************/

BOOL EXPENTRY RptRegisterClass(HAB hab);

#endif
